#include <windows.h>

BOOL CALLBACK DlgProc (HWND, UINT, WPARAM, LPARAM) ;

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
     DialogBox (hInstance, TEXT ("MOJ_DIALOG"), NULL, DlgProc) ;
}


HFONT GetFont (int uHeight, int iWeight)
{
	return CreateFont (uHeight, (UINT) (uHeight / 2.3), 0, 0, iWeight,
			0, 0, 0, EASTEUROPE_CHARSET, OUT_TT_PRECIS, CLIP_CHARACTER_PRECIS,
			PROOF_QUALITY, FF_SCRIPT, NULL) ;
}


void Pisz(HDC hdc, COLORREF kolor)
{
    SIZE  siz ;
    TCHAR bufor[256];
    wsprintf (bufor, TEXT ("Kocham Ci, i nic tego nie zmieni!"));
    
    int blue = GetBValue(kolor);
    
    HFONT hFont = GetFont (25, FW_NORMAL) ;

    HFONT hstary_font = (HFONT) SelectObject (hdc, hFont);
    GetTextExtentPoint32 (hdc, bufor, lstrlen (bufor), &siz) ;
    SetBkMode (hdc, TRANSPARENT) ;
//    SetBkColor(hdc, RGB(0,0,0));
    SetTextColor (hdc, kolor) ;
    TextOut (hdc, (500 - siz.cx) / 2,
	  (250 - siz.cy) / 2, bufor, lstrlen (bufor)) ;
    SelectObject (hdc, hstary_font);
    DeleteObject (hFont) ;
}


BOOL CALLBACK DlgProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	 static HRGN	hRgn ;
	 static POINT	pt ;
	 static COLORREF kolor = RGB(255,255,255);
	      
     switch (message)
     {
     case WM_INITDIALOG:
     {
          int size_x = GetSystemMetrics(SM_CXSCREEN);
          int size_y = GetSystemMetrics(SM_CYSCREEN);
          
 		  MoveWindow (hwnd, size_x/2 - 250, size_y/2 - 125,
                            size_x/2 + 250, size_y/2 + 125, TRUE) ;
		  hRgn = CreateEllipticRgn (0, 0, 500, 250) ;

		  SetWindowRgn (hwnd, hRgn, TRUE) ;
		  
          SetTimer (hwnd, 10, 20, NULL) ;

          return TRUE ;
     }
	 case WM_LBUTTONDOWN:
		 SetCapture (hwnd) ;
	     pt.x = LOWORD(lParam);
         pt.y = HIWORD(lParam);	 
		 SetTimer (hwnd, 1, 1, NULL) ;
		 return TRUE ;
 	 case WM_CAPTURECHANGED:
		 if ((HWND) lParam == hwnd)
			 break ;
	 case WM_LBUTTONUP:
		 KillTimer (hwnd, 1) ;
		 return TRUE ;
	 
	 
	 case WM_TIMER:
	 {    
	     if (wParam == 1)
	     {
	        POINT	ptTemp;
	        GetCursorPos (&ptTemp) ;
	        MoveWindow (hwnd, ptTemp.x - pt.x, ptTemp.y - pt.y,
			  500, 250, TRUE) ;
         }
         else
         {
            static int db = -2;
            static int dg = -3;
            int blue = GetBValue(kolor);
            int green = GetGValue(kolor);
            blue += db;
            green += dg;
            if (blue < 0 || blue > 255)
            {
               db = -db;
               blue += 2*db;
            }
            if (green < 0 || green > 255)
            {
               dg = -dg;
               green += 2*dg;
            }

            kolor = RGB(255, green, blue);
            HDC hdc = GetDC(hwnd);
            Pisz(hdc, kolor);
            ReleaseDC(hwnd, hdc);
         }
		 return TRUE ;
     }
	 case WM_RBUTTONDOWN:
		 ReleaseCapture () ;
		 EndDialog(hwnd, 0) ;
		 return TRUE ;
          
     case WM_PAINT:
     {
          PAINTSTRUCT	ps ;
          RECT			rect ;
	
    	  GetClientRect (hwnd, &rect) ;
          HDC hdc = BeginPaint (hwnd, &ps) ;

		  HPEN hPen = CreatePen (PS_SOLID , 10, RGB (0, 255, 255)) ;
		  
          HPEN hstary_pen = (HPEN)SelectObject (hdc, hPen); 
		  HBRUSH hstary_brush = (HBRUSH)SelectObject (hdc, GetStockObject (BLACK_BRUSH));
		  
		  Ellipse (hdc, 0, 0, 500, 250) ;

          Pisz(hdc, kolor);     
          
          SelectObject (hdc, hstary_brush);
          SelectObject (hdc, hstary_pen);

		  DeleteObject (hPen) ;
          
          EndPaint (hwnd, &ps) ;
          return TRUE ;
     }     
     case WM_DESTROY:
		  if (GetCapture () == hwnd)
			 ReleaseCapture () ;
		  DeleteObject (hRgn) ;
          return TRUE ;
     }
     return FALSE ;
}
