#include <windows.h> // tu sa deklaracje podstawowych funkcji windowsowych
#include <time.h>    // tu jest deklaracja funkcji time
#include <assert.h>  // tu jest deklaracja makrodefinicji assert
#include <stdlib.h>  // tu jest deklaracja funkcji rand
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "ising.h"

HINSTANCE hinst;


const int max_x_size = 800;
const int max_y_size = 600;
const int max_1_size = max_x_size*max_y_size;

    // poziomy rozmiar planszy (nieparzysty!)
const int x_size[4] = {max_x_size/8, max_x_size/4, max_x_size/2, max_x_size};
    // pionowy rozmiar planszy (nieparzysty!)
const int y_size[4] = {max_y_size/8, max_y_size/4, max_y_size/2, max_y_size};
const int pix_bok[4] = {8, 4, 2, 1};       // szerokosc pola planszy w pikselach
const int client_x[4] = {x_size[0] * pix_bok[0], // szerokosc obszaru roboczego okna (piksele)
                         x_size[1] * pix_bok[1],
                         x_size[2] * pix_bok[2],
                         x_size[3] * pix_bok[3]};
const int client_y[4] = {y_size[0] * pix_bok[0],    // wysokosc obszaru roboczego okna (piksele)
                         y_size[1] * pix_bok[1],
                         y_size[2] * pix_bok[2],
                         y_size[3] * pix_bok[3]};
const int czas_odswiezania = 1;

enum Stan {Plus = 1, Minus = -1};

const COLORREF kolor_plus = RGB(200,0,0);
const COLORREF kolor_minus = RGB(0,0,255);

const HBRUSH pedzel_plus  = CreateSolidBrush(kolor_plus);
const HBRUSH pedzel_minus = CreateSolidBrush(kolor_minus);
const HBRUSH pedzel_tla = (HBRUSH)GetStockObject(WHITE_BRUSH);   



/* *************  ZMIENNE GLOBALNE (DEFINIUJ STAN PROGRAMU) *********** */ 

int i_rozmiar = 1; // wielko planszy
int NN = true;
int max_t = 600;

Stan plansza[max_x_size][max_y_size];       // pola planszy - kazde ma okreslony stan


bool pause;
bool ekran_powitalny;
int iEnergia;
int iMagn;
int i_temperatura = NN ? max_t - 227 : max_t - 227*2;
double temperatura = i_temperatura/100.0;;

int step = 0;
double prob[9];

// deklaracja zapowiadajca procedury okna
LRESULT CALLBACK ProceduraOkna (HWND, UINT, UINT, LONG); 

inline double Drandom()
{
    return rand()/double(RAND_MAX+1);
}

// generator liczb pseudolosowych z zakresu 0..n-1.
inline int Random(int n)
{
  return int(Drandom()*n);
}


// znajduje poczatkowe poozenie i rozmiar okna aplikacji
// oraz sprawdza, czy karta graficzna pracuje w odpowiednim trybie
// Wartosc zwracana: true, jeli mona utworzy okno o danym rozmiarze
bool ZnajdzRozmiarOkna(RECT& rect, int flagi, int flagiEx, BOOL jestMenu)
{
   int max_x = GetSystemMetrics(SM_CXSCREEN);
   int max_y = GetSystemMetrics(SM_CYSCREEN);

   int dx = (max_x - client_x[i_rozmiar])/2;
   int dy = (max_y - client_y[i_rozmiar])/2;

   rect.left = dx;
   rect.top = dy;
   rect.right = max_x - dx;
   rect.bottom = max_y - dy;
   if (flagi & WS_VSCROLL)
     rect.right += GetSystemMetrics(SM_CYHSCROLL);
   AdjustWindowRectEx (&rect, flagi, jestMenu, flagiEx);
     if (rect.left < 0 || rect.top < 0)
   {
     MessageBox(0, "Program Ising (wersja 0.2) wymaga uruchamiania\n"
                   "w trybie o rozdzielczoci co najmniej 1204*768 pikseli!\n"
                   "\n"
                   "Program wymaga wic zmiany trybu pracy karty graficznej\n"
                   "(Win98: Pulpit / Waciwoci / Ustawienia / Obszar ekranu).",
                "Ising (0.2)", 
                MB_OK | MB_ICONERROR);               
     return false; // bd!
   }
   return true; // ok
}


int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE, 
                    LPSTR , int nCmdShow)		   
{
  const char nazwa_klasy_okien[] = "MojeOkno";
  ::hinst = hInstance;
  srand(time(0));  // inicjacja generatora liczb pseudolosowych

  WNDCLASSEX  wndclass = {0};
  wndclass.cbSize       	= sizeof(WNDCLASSEX);
  wndclass.style        	= CS_HREDRAW | CS_VREDRAW;  
  wndclass.lpfnWndProc  	= ProceduraOkna; 
  wndclass.hInstance    	= hInstance;                
  wndclass.hCursor      	= LoadCursor (NULL, IDC_ARROW);	
  wndclass.hIcon        	= LoadIcon   (NULL, IDI_APPLICATION); 
  wndclass.hbrBackground	= pedzel_plus;
  wndclass.lpszClassName	= nazwa_klasy_okien;
  wndclass.hIconSm      	= LoadIcon   (NULL, IDI_APPLICATION);
  RegisterClassEx (&wndclass);

  // ustalamy poczatkowy rozmiar gwnego okna aplikacji
  // wynik zapisujemy w prostokcie rect:
  RECT rect;
  DWORD flagi = WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_VSCROLL;
  DWORD flagi_ex = 0;
  bool jest_menu = true;
  bool ok = ZnajdzRozmiarOkna (rect, flagi, flagi_ex, jest_menu);
  if (!ok)
    return 0; // awaryjne zakoczenie programu


  HWND hwnd = CreateWindowEx (
    flagi_ex,
    nazwa_klasy_okien,
    "Ising",
    flagi,			
    rect.left, rect.top, 
    rect.right - rect.left, rect.bottom - rect.top,
    NULL,
    LoadMenu(hInstance, "ising"),
    hInstance,
    NULL
    );
  if (hwnd == 0)
    return -1;
  
  ShowWindow (hwnd, nCmdShow);

  HACCEL haccel = LoadAccelerators(hInstance, "ising");
  
  /* Ptla komunikatw: */
  int result;
  MSG msg;
  while ((result = GetMessage (&msg, NULL, 0, 0) ) != 0)
  {
    if (result == -1)
        return -1;
    if ( !TranslateAccelerator(hwnd, haccel, &msg) )
    {
        TranslateMessage (&msg);
        DispatchMessage (&msg);
    }
  }
  
  // kocowe poprzdki - higiena ponad wszystko!
  DeleteObject(pedzel_plus);
  DeleteObject(pedzel_minus);

  return msg.wParam;
}

// ******************************************************** //
// ** AktualizujTytul ustala biecy tytu okna gwnego ** //
// ******************************************************** //
void AktualizujTytul(HWND hwnd)
{
  if (ekran_powitalny)
  {
    SetWindowText(hwnd, "Ising: przycisnij klawisz Esc, a program nabierze tempa!");
    return;
  }
  double mian = x_size[i_rozmiar]*y_size[i_rozmiar];
  double e = 4*iEnergia/mian;
  double m = 2*iMagn / mian;
  if (!NN)
    e *= 2.0;
  char bufor[128];
  sprintf (bufor, "Ising: krok %d, energia = %.2f, "
                  "namagnesowanie = %.2f, temperatura = %.2f", 
    step, e, m, ::temperatura);
  SetWindowText(hwnd, bufor);
}


void RysujPole(HDC hdc, int x, int y)
{
  if (hdc == 0)
    return;

  assert (i_rozmiar >= 0 && i_rozmiar < 4);
  assert (x >= 0 && x < x_size[i_rozmiar]);
  assert (y >= 0 && y < y_size[i_rozmiar]);
  assert (plansza[x][y] == Plus || plansza[x][y] == Minus);

  int pbok =pix_bok[i_rozmiar];
  if (pbok > 1)
  {
    int x0 = x*pbok;
    int y0 = y*pbok;
    RECT rect = {x0, y0, x0 + pbok, y0 + pbok};
    HBRUSH hbr = (plansza[x][y] == Plus) ? pedzel_plus : pedzel_minus;
    FillRect(hdc, &rect, hbr);
  }
  else
  {
    COLORREF cr = (plansza[x][y] == Plus) ? kolor_plus : kolor_minus;
    SetPixel(hdc, x, y, cr);
  }
}



void NoweT()
{
  temperatura = (max_t-i_temperatura)/100.0;
  if (temperatura > 1e-10)
    prob[2] = exp(-2*2/temperatura);
  else
    prob[2] = 0.0;
  prob[4] = prob[2]*prob[2];
  prob[6] = prob[2]*prob[4];
  prob[8] = prob[2]*prob[6];}


void NowaGra(HWND hwnd)
{
  max_t = NN ? 500 : 1000;
  i_temperatura = NN ? max_t - 227 : max_t - 227*2;

  SCROLLINFO si = {0};
  si.cbSize = sizeof(SCROLLINFO);
  si.nMax = max_t;
  si.nMin = 0;
  si.nPage = 1;
  si.nPos = i_temperatura;
  si.fMask = SIF_ALL;
  SetScrollInfo(hwnd, SB_VERT, &si, TRUE);


  const int tab[4] = {IDM_R1, IDM_R2, IDM_R3, IDM_R4};

  NoweT();
  step = 0;
  int ilocz =x_size[i_rozmiar]*y_size[i_rozmiar];
  iEnergia = -ilocz;
  iMagn = ilocz/2;
  pause = true;
  ekran_powitalny = true;
  bool paused_at_menu = true;
  
  HMENU hMenu = GetMenu(hwnd);
  HMENU hm = GetSubMenu(hMenu,2);
  hm = GetSubMenu(hm,0);
  for (int i = 0; i < 4; i++)
  {
    int flaga =  (i == i_rozmiar) ? MF_CHECKED : MF_UNCHECKED;
    CheckMenuItem(hMenu, tab[i], MF_BYCOMMAND | flaga );
  }
  const int tab2[2] = {IDM_NN, IDM_NNN};
  const bool stan[2] = {NN, !NN};
  for (int i = 0; i < 2; i++)
  {
    int flaga = stan[i] ? MF_CHECKED : MF_UNCHECKED;
    CheckMenuItem(hMenu, tab2[i], MF_BYCOMMAND | flaga );
  }
//  CheckMenuItem (hMenu, IDM_NN, MF_BYCOMMAND | MF_CHECKED);

  const int xs = x_size[i_rozmiar];
  const int ys = y_size[i_rozmiar];

  for (int k = 0; k < xs; k++)
  {
    for (int i = 0; i < ys; i++)
      plansza[k][i] = Plus;
  }
  
  InvalidateRect (hwnd, 0, true);            // uniewaniamy wygld caego okienka
  UpdateWindow (hwnd);                       // damy, by okienko zostao natychmiast odmalowane 
  AktualizujTytul(hwnd);                     // aktualizujemy pasek tytuowy
}

// *********************************************************************** //
// *** OdrysujPlansze odrysowywuje na hdc biecy wygld caej planszy *** //
// *********************************************************************** //
void OdrysujPlansze(HDC hdc, int szer, int wys)
{
  HDC hdc_mem = CreateCompatibleDC (hdc);

  HBITMAP hbitmap = CreateCompatibleBitmap(hdc, szer, wys);
  HBITMAP hbm_old = (HBITMAP) SelectObject(hdc_mem, hbitmap);

  for (int x = 0; x < x_size[i_rozmiar]; x++)
  {
    for (int y = 0; y < y_size[i_rozmiar]; y++)
    {
        RysujPole(hdc_mem, x, y);
    }
  }
  BitBlt(hdc,     0, 0, szer, wys,
         hdc_mem, 0, 0, SRCCOPY);

  DeleteObject(SelectObject(hdc_mem, hbm_old));
  DeleteDC (hdc_mem);
}



void WstrzymajGre(HWND hwnd)
{
  if (::ekran_powitalny)
    return;
  pause = true;
  HMENU hMenu = GetMenu(hwnd);
  ModifyMenu(hMenu, IDM_STOP, MF_BYCOMMAND | MF_STRING,IDM_STOP , "&Wznw" );
  DrawMenuBar(hwnd);
}

void WznowGre(HWND hwnd)
{
  pause = false;
  HMENU hMenu = GetMenu(hwnd);
  ModifyMenu(hMenu, IDM_STOP, MF_BYCOMMAND | MF_STRING, IDM_STOP , "&Stop" );
  DrawMenuBar(hwnd);
  if (ekran_powitalny)
  {
     assert (!pause);
     ekran_powitalny = false;
  }

}

void SingleMC(HDC hdc)
{
    const int xs = x_size[i_rozmiar];
    const int ys = y_size[i_rozmiar];
    const int x = Random(xs);
    const int y = Random(ys);
    
//    int z = Random(xs*ys);
//    const int y = z/xs;
//    const int x = z - y*xs;

    
    const int spin = plansza[x][y];
    const int xp = (x == xs - 1) ? 0 : x+1;
    const int xm = (x == 0) ? xs - 1 : x-1;
    const int yp = (y == ys - 1) ? 0 : y+1;
    const int ym = (y == 0) ? ys - 1 : y-1;
    int sum_spin = plansza[x][yp] + plansza[x][ym] +
                   plansza[xp][y] + plansza[xm][y];
                         
    if (!NN)
    {
        sum_spin += plansza[xp][yp] + plansza[xp][ym] +
                    plansza[xm][yp] + plansza[xm][ym];
    }
    
    int dE_2 = (spin == 1) ? sum_spin : -sum_spin; 
    if (dE_2 <= 0 || Drandom() < prob[dE_2] )
    {
        plansza[x][y] = Stan(-plansza[x][y]);
        RysujPole(hdc, x, y);
        iEnergia += dE_2;
        iMagn += plansza[x][y];
    }
}



void OnEscape(HWND hwnd)
{
   if (pause)
     WznowGre(hwnd);
   else
     WstrzymajGre(hwnd);          
}

void MC_Step(HDC hdc)
{
   ::step++;
   const int max = x_size[i_rozmiar]*y_size[i_rozmiar];
   for (int x = 0; x < max; x++)
      SingleMC(hdc);
}


/***   PROCEDURA OKNA   ***/

LRESULT CALLBACK ProceduraOkna (HWND hwnd, UINT message,
                                UINT wParam, LONG lParam)
{
  const int numer_zegara = 1;
  static HWND hscroll;
  static bool paused_at_menu = true;
  switch(message)
  {
    case WM_CREATE:
    {
      NowaGra(hwnd);
      SetTimer (hwnd, numer_zegara, czas_odswiezania, 0);
      return 0;
    }
    case WM_VSCROLL: 
    {
        switch(LOWORD (wParam)) 
        { 
            case SB_PAGEUP: 
              ::i_temperatura -= 10; 
            break; 
            case SB_PAGEDOWN: 
              ::i_temperatura += 10; 
                 break; 
            case SB_LINEUP: 
              ::i_temperatura--; 
            break; 
            case SB_LINEDOWN: 
              ::i_temperatura++;
            break; 
            case SB_THUMBTRACK: 
               ::i_temperatura = HIWORD(wParam); 
            break; 
            case SB_THUMBPOSITION: 
               ::i_temperatura = HIWORD(wParam); 
            break; 
       }

        if (i_temperatura <= 0)
          i_temperatura = 0;
        if (i_temperatura > max_t)
          i_temperatura = max_t;

        SCROLLINFO si = {0};        
        si.cbSize = sizeof(si); 
        si.fMask  = SIF_POS; 
        si.nPos   = i_temperatura;
        SetScrollInfo(hwnd, SB_VERT, &si, TRUE);
        NoweT();
        AktualizujTytul(hwnd);
        return 0;
    }
    case WM_DESTROY:
    {
      KillTimer(hwnd, numer_zegara);
      PostQuitMessage (0);
      return 0;
    }

    case WM_TIMER:
    {
      if (pause)
        return 0;
      HDC hdc = GetDC(hwnd);

      RECT rect;
      GetClientRect(hwnd, &rect);
      MC_Step(hdc);
      ReleaseDC(hwnd, hdc);
      AktualizujTytul(hwnd);
      return 0;
    }

    case WM_RBUTTONDOWN:
    {
        HMENU hmenu = GetMenu(hwnd);
        hmenu = GetSubMenu(hmenu,1);
        POINT  punkt = {LOWORD(lParam), HIWORD(lParam)};
        ClientToScreen(hwnd, &punkt);
        TrackPopupMenu(hmenu, TPM_LEFTALIGN	 | TPM_RIGHTBUTTON	, punkt.x, punkt.y, 0, hwnd, 0);
    }
    case WM_KEYDOWN:
    {
      WORD wScrollNotify = 0xFFFF; 

      switch(wParam)
      {
      case VK_ESCAPE:
        OnEscape(hwnd);
        break;

      case VK_UP: 
        wScrollNotify = SB_LINEUP; 
        break; 
        
      case VK_PRIOR: 
        wScrollNotify = SB_PAGEUP; 
        break; 
        
      case VK_NEXT: 
        wScrollNotify = SB_PAGEDOWN; 
        break; 
        
      case VK_DOWN: 
        wScrollNotify = SB_LINEDOWN; 
        break; 
        
      case VK_HOME: 
        wScrollNotify = SB_TOP; 
        break; 
        
      case VK_END: 
        wScrollNotify = SB_BOTTOM; 
        break; 
      } 
 
      if (wScrollNotify != 0xFFFF)
        SendMessage(hwnd, WM_VSCROLL, MAKELONG(wScrollNotify, 0), 0L); 

      return 0;
    }
    case WM_COMMAND:
    {
      if (lParam != 0) // dla menu i akceleratorw lParam == 0
         break;
      switch(LOWORD(wParam))
      {
        case IDM_STOP:
          OnEscape(hwnd);
        break;
        case IDM_KONIEC:
          SendMessage(hwnd, WM_CLOSE, 0, 0);
        break;
        case IDM_POMOC:
        {
          bool pp = pause;
          if (!pp)
            WstrzymajGre(hwnd);
          MessageBox(hwnd,
            "Prosta symulacja modelu Isinga\n"
            "(dwuwymiarowy magnes w kontakcie cieplnym z termostatem o temperaturze T)\n"
            "kolor czerwony: lokalne namagnesowanie w \"gre\",\n" 
            "kolor niebieski: lokalne namagnesowanie w \"d\"\n\n"
            "Wersja 0.2\n"
            "(c) Zbigniew Koza (2002)\n\n"
            "Prawy suwak zmienia temperatur\n"
            "ESC wstrzymuje/wznawia symulacje\n"
            "Biece parametry fizyczne wyswietlane s na pasku tytuowym. S to:\n"
            "numer kroku Monte Carlo (czas), energia, namagnesowanie, temperatura\n\n"
            "Opcje:\n"
            "\tRozmiar: ustala rozmiar ukadu\n"
            "\tZasig:  ustala zasig oddziaywania:\n"
            "\t\tNN  = 4 najbliszych ssiadw,\n"
            "\t\tNNN = 8 najbliszych i nastpnych ssiadw\n\n"
            "Teoretyczna temperatura przejcia fazowego (NN, ukad nieskoczony): 2,269185\n"
            "\t(jest to poczatkowa temperatura kadej nowej symulacji)\n"
            "Powyej tej temperatury namagnesowanie znika (w ukadzie nieskoczonym)\n\n"
            "Miej zabawy!", "Info", 0);
          if (!pp)
            WznowGre(hwnd);
        break;
        }

        case IDM_R1:
           WstrzymajGre(hwnd);
           i_rozmiar = 0;
           NowaGra(hwnd);
        break;
        case IDM_R2:
           WstrzymajGre(hwnd);
           i_rozmiar = 1;
           NowaGra(hwnd);
        break;
        case IDM_R3:
           WstrzymajGre(hwnd);
           i_rozmiar = 2;
           NowaGra(hwnd);
        break;
        case IDM_R4:
           WstrzymajGre(hwnd);
           i_rozmiar = 3;
           NowaGra(hwnd);
        break;
        case IDM_NN:
           WstrzymajGre(hwnd);
           NN = true;
           NowaGra(hwnd);
        break;
        case IDM_NNN:
           WstrzymajGre(hwnd);
           NN = false;
           NowaGra(hwnd);
        break;
      }
          
      return 0;
    }
    case WM_PAINT:
    {
      PAINTSTRUCT ps;
    
      HDC hdc = BeginPaint (hwnd, &ps);
      RECT rect;
      GetClientRect(hwnd, &rect);
      OdrysujPlansze(hdc, rect.right, rect.bottom);
      AktualizujTytul(hwnd);
      EndPaint (hwnd, &ps);
      return 0;
    }
    
    case WM_INITMENU:
      paused_at_menu = pause;
      WstrzymajGre(hwnd);
      return 0;
    case WM_EXITMENULOOP:
      if (!paused_at_menu)
         WznowGre(hwnd);
      return 0;

    case WM_CLOSE:
    {
      if (!pause)
        WstrzymajGre(hwnd);
      int wynik =  MessageBox(hwnd, "Naprawd chcesz zakoczy program?",
                              "Koczymy?", MB_YESNO | MB_ICONEXCLAMATION);
      if (wynik == IDYES)
        DestroyWindow(hwnd);
      return 0;
    }
  }
  return DefWindowProc (hwnd, message, wParam, lParam);
}
