// ************************************************************************ //
// ****   Programik demonstrujcy prosty przycisk                       *** //
// ****   (c;-) Zbigniew Koza, 2002, wersja 1.1                         *** //
// ****   Bd w wersji 1.0 wskaza Tomasz Plaskowski <tpla@interia.pl> *** //
// ************************************************************************ //


#include <windows.h>
#include <stdlib.h>   // tu jest deklaracja funkcji rand [generator liczb pseudolosowych]
#include <time.h>     // tu jest deklaracja funkcji time

LRESULT CALLBACK ProceduraOkna (HWND, UINT, UINT, LONG); // deklaracja procedury okien
HINSTANCE hinst;             // miejsce na globalnie dostpny "magiczny numer programu"


int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, 
                    LPSTR lpszCmdParam, int nCmdShow)		   
{
    ::hinst = hInstance;  // inicjacja ::globalnej zmiennej hinst
    srand(time(0));       // inicjacja generatora liczb pseudolosowych

    // przygotowanie i rejestracja klasy okien
    const char nazwa_klasy_okien[] = "MojeOkno";
    WNDCLASSEX  wndclass = {0};                                  // definicja struktury
    wndclass.cbSize       	= sizeof(WNDCLASSEX);                // rozmiar struktury
    wndclass.style        	= CS_HREDRAW | CS_VREDRAW;           // styl okna
    wndclass.lpfnWndProc  	= ProceduraOkna;    // adres NASZEJ funkcji uzywanej przez Windows
    wndclass.hInstance    	= hInstance;                
    wndclass.hCursor      	= LoadCursor (NULL, IDC_ARROW);	
    wndclass.hIcon        	= LoadIcon   (NULL, IDI_APPLICATION); 
    wndclass.hbrBackground	= (HBRUSH) GetStockObject (WHITE_BRUSH);  // pdzel
    wndclass.lpszClassName	= nazwa_klasy_okien;                      // nazwa klasy okien
    wndclass.hIconSm      	= LoadIcon   (NULL, IDI_APPLICATION);     // maa ikona
    
    RegisterClassEx (&wndclass);
    // CreateWindowEx zwraca uchwyt nowotworzonego okna	
    HWND hwnd =                  
        CreateWindowEx ( 0,             // style dodatkowe (tu: 0 = brak)
        nazwa_klasy_okien,              // nazwa uywanej klasy okien
        "Przyciski w oknie",	        // tytu okienka
        WS_OVERLAPPEDWINDOW,			// podstawowe style okna
        CW_USEDEFAULT, CW_USEDEFAULT,   // pooenie lewego grnego naronika okna
        CW_USEDEFAULT, CW_USEDEFAULT,   // szeroko, wysoko okna
        NULL,                           // uchwyt okna nadrzdnego; 0 = brak
        NULL,                           // menu; 0 = brak
        hInstance,                      // "numer" programu
        NULL);                          // tylko dla zaawansowanych uytkownikw
        
    if (hwnd == 0)
        return -1;

    ShowWindow (hwnd, nCmdShow);        // wywietla okno
    
    // Ptla komunikatw:
    int result;  // tu bdziemy zapisywa wynik dzialania funkcji GetMessage
    MSG msg;     // tu Windows bdzie umieszcza komunikaty
    while ((result = GetMessage (&msg, 0, 0, 0) ) != 0)
    {
        if (result == -1)         // -1 sygnalizuje bd
            return -1;            // awaryjne zakonczenie programu
        TranslateMessage (&msg);  // to trudno wyjani w 1 zdaniu (i mona to tu pomin)
        DispatchMessage (&msg);   // wysyamy komunikat do procedury okna     
    }	                                   
    
    return msg.wParam;  // funkcja,
}


// ************************** //
// ***   PROCEDURA OKNA   *** //
// ************************** //

LRESULT CALLBACK ProceduraOkna (HWND hwnd, UINT message,
                                UINT wParam, LONG lParam)
{
  const int przycisk_id = 1;    // identyfikator przycisku
  const int szerokosc = 350;    // szerokosc przycisku (w pikselach)
  const int wysokosc = 30;      // wysokosc przycisku (w pikselach)

  static HWND hbutton;     // uchwyt przycisku
  static int ile = 10;     // ile razy mona jeszcze przycisn hbutton
  
  switch(message)
  {
    // komunkiat WM_CREATE sygnalizuje moment tworzenia okna
    // tworzymy teraz nowe okno - przycisk hbutton o identyfikatorze przycisk_id
    case WM_CREATE:
      hbutton = CreateWindowEx (0,       // brak wydumanego stylu dodatkowego
          "BUTTON",                      // nazwa standardowej klasy okien
          "przycinij mnie!",            // tekst na przycisku
          WS_CHILD | WS_VISIBLE  | BS_DEFPUSHBUTTON, // zasadniczy styl przycisku
          10, 10, szerokosc, wysokosc,   // poozenie
          hwnd,                          // waciciel przycisku
          HMENU(przycisk_id),            // identyfikator przycisku (zamaist menu)
          ::hinst,                       // id programu
          0);                            // zero ;-)
      return 0;
    
    // komunikat WM_COMMAND generowany jest przez standardowe okna potomne
    // identyfikator okienka genurujcego komunikat = LOWORD(wParam)
    // przyczyna wygenerowania tego komunikatu = HIWORD(wParam) [tu: nieuywane]
    case WM_COMMAND:
      // czy komunikat pochodzi od naszego przycisku?
      if (LOWORD(wParam) == przycisk_id) 
      {
        // zmniejszamy liczb wci moliwych przycini
        ile--;               
        
        // rezerwujemy miejsce na nowy tekst wywietlany na przycisku
        // inicjujemy napisem, ktry nie ma prawa przedosta si do uytkownika!
        char bufor[128] = "Bd 0001: skontaktuj si ze sprzedawc!";
        
        // teraz zmieniamy tekst wywietlany na przycisku
        if (ile > 0)
        {
          // ustalamy napis, ktry ma by teraz wywietlany na przycisku
          const char* koncowka = (ile == 1) ? "" : "y";
          
          // tak, wsprint jest piekne (cho sprintf jescze piekniejsze...)
          wsprintf(bufor, "moesz mnie jeszcze przycisn %d raz%s!", ile, koncowka);
          
          // przesuwamy okienko w losowo wybrane pooenie
          MoveWindow(hbutton,                          // ktre okno przesun?
                     int(rand()%200), int(rand()%200), // gdzie przesun?
                     szerokosc, wysokosc,              // nowy rozmiar?
                     true);                            // czy ma by natychmiast odmalowane?
        }
        else   // trzeba wyczy przycisk
        {    
          wsprintf(bufor, "nie moesz mnie ju przyciska!");
          EnableWindow(hbutton, false);  // false = "wyczamy okno"
        }
        // nowy napis wywietlany na przycisku odczytujemy z tablicy bufor
        SetWindowText(hbutton, bufor);   
      }
      return 0;
   
    // Komunikat WM_SETFOCUS sygnalizuje, ze nasze okno wanie otrzymao ognisko klawiatury
    case WM_SETFOCUS:
      // chcemy, by nasz przycisk, o ile jest aktywny, dao si *zawsze* przycisn spacj
      // w tym celu, jesli tylko ma to sens, przekazujemy mu ognisko ("focus") klawiatury
      if (IsWindowEnabled(hbutton))
      {
        SetFocus(hbutton); 
      }
      return 0;
      
    case WM_DESTROY:
      PostQuitMessage (0);              // przerywa WinMain i konczy program
      return 0;
  }
  
  // standardowa obsuga pominitych przez nas komunikatw
  return DefWindowProc (hwnd, message, wParam, lParam);
}
