#include <windows.h>
#include <stdlib.h>   // <--tu jest definicja funkcji rand

LRESULT CALLBACK ProceduraOkna (HWND, UINT, UINT, LONG); // deklaracja zapowiadajca

HINSTANCE hinst;

const int szerokosc = 350;   // szerokosc okna "edytora"
const int wysokosc = 30;     // wysokosc okna "edytora"

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, 
                    LPSTR lpszCmdParam, int nCmdShow)		   
{
    const char nazwa_klasy_okien[] = "MojeOkno";
    HWND        hwnd; 
    MSG         msg;
    WNDCLASSEX  wndclass;
    
    hinst = hInstance;

    wndclass.cbSize       	= sizeof(WNDCLASSEX);
    wndclass.style        	= CS_HREDRAW | CS_VREDRAW;  
    wndclass.lpfnWndProc  	= ProceduraOkna; 
    wndclass.cbClsExtra   	= 0; 
    wndclass.cbWndExtra   	= 0; 
    wndclass.hInstance    	= hInstance;                
    wndclass.hCursor      	= LoadCursor (NULL, IDC_ARROW);	
    wndclass.hIcon        	= LoadIcon   (NULL, IDI_APPLICATION); 
    wndclass.hbrBackground	= (HBRUSH) GetStockObject (LTGRAY_BRUSH);
    wndclass.lpszMenuName 	= NULL;
    wndclass.lpszClassName	= nazwa_klasy_okien;
    wndclass.hIconSm      	= LoadIcon   (NULL, IDI_APPLICATION);
    
    ATOM a = RegisterClassEx (&wndclass);	
    hwnd = CreateWindowEx ( 0,
        nazwa_klasy_okien,
        "Przyciski w oknie",	          // tytu okna
        WS_DLGFRAME,			          // ramka jak w oknie dialogowym
        CW_USEDEFAULT, CW_USEDEFAULT,     // polozenie okna
        szerokosc + 28, 6*wysokosc + 28,  // szerokosc, wysokosc
        NULL,
        NULL,                             // menu
        hInstance,
        NULL
    );
    if (hwnd == 0)
        return -1;

    ShowWindow (hwnd, nCmdShow);			
    
    /* Ptla komunikatw: */
    int result;
    while ((result = GetMessage (&msg, NULL, 0, 0) ) != 0) 
    {
        if (result == -1) return -1;
        TranslateMessage (&msg);
        DispatchMessage (&msg);            
    }	                                    
    return msg.wParam;
}


// **************************
// ***   PROCEDURA OKNA   ***
// **************************

LRESULT CALLBACK ProceduraOkna (HWND hwnd, UINT message,
                                UINT wParam, LONG lParam)
{
  // trzy identyfikatory przyciskw
  const int numer_edit = 1;
  const int numer_push = 2;
  const int numer_static = 3;
   
  static HWND h_edit;       // uchwyt okienka "edytora"
  
  switch(message)
  {
    case WM_CREATE: 
      CreateWindowEx (0,
                  "Static", "Napisz krtk wiadomo!", 
                  WS_CHILD | WS_VISIBLE,         // flagi  
                  10, 10, szerokosc, wysokosc*3, // polozenie i wielkosc
                  hwnd,
                  HMENU(numer_static),           // numer okienka
                  hinst, 0);
      h_edit = CreateWindowEx (WS_EX_CLIENTEDGE,
                  "EDIT", "Wybrbuj ctrl-c, ctrl-v, ctrl-z itp...",
                  WS_CHILD | WS_VISIBLE  | ES_LEFT | ES_MULTILINE,
                  10, 10+wysokosc, szerokosc, wysokosc*3,  
                  hwnd,
                  HMENU(numer_edit), 
                  hinst, 0);
      CreateWindowEx (0, 
                  "BUTTON", "OK", 
                  WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON, 
                  10, 20+wysokosc*4, szerokosc, wysokosc, 
                  hwnd, 
                  HMENU(numer_push),
                  hinst, 0);
      return 0;                     // 0 = "komunikat przetworzony"
    case WM_COMMAND:
      if (LOWORD(wParam) == numer_push)
      {            
        char bufor[500];        // bufor napisu, wprowadzonego do edytora
        GetWindowText(h_edit, bufor, 500); // odczytuje tekst z "edytora" h_edit
        ShowWindow(hwnd, SW_HIDE);         // ukrywa okno gwne (hwnd)
        MessageBox(hwnd, bufor,            // wyswietla komunikat
                   "W okienku edytora wybrano:", 0);
        DestroyWindow(hwnd);               // niszczy okno gwne (i podrzedne)
      }
      return 0;
    case WM_DESTROY:
      PostQuitMessage (0);                 // przerywa WinMain
      return 0;
  }
  return DefWindowProc (hwnd, message, wParam, lParam);
}
