#include <windows.h>
#include <stdlib.h>   // <--tu jest definicja funkcji rand

LRESULT CALLBACK ProceduraOkna (HWND, UINT, UINT, LONG); // deklaracja zapowiadajca

HINSTANCE hinst;             // globalna zmienna przechowujca "magiczny numer" programu

const int szerokosc = 350;   // szerokosc okna "edytora"
const int wysokosc = 30;     // wysokosc okna "edytora"

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, 
                    LPSTR lpszCmdParam, int nCmdShow)		   
{
    const char nazwa_klasy_okien[] = "MojeOkno";
    HWND        hwnd; 
    MSG         msg;
    WNDCLASSEX  wndclass;
    
    ::hinst = hInstance;      // ustalamy warto globalnej zmiennej hinst

    wndclass.cbSize       	= sizeof(WNDCLASSEX);
    wndclass.style        	= 0;                                   // styl nieawangardowy
    wndclass.lpfnWndProc  	= ProceduraOkna;                       // proc. okna
    wndclass.cbClsExtra   	= 0; 
    wndclass.cbWndExtra   	= 0; 
    wndclass.hInstance    	= hInstance;                
    wndclass.hCursor      	= LoadCursor (NULL, IDC_ARROW);	       // kursor
    wndclass.hIcon        	= LoadIcon   (NULL, IDI_APPLICATION);  // ikona
    wndclass.hbrBackground	= (HBRUSH) GetStockObject (LTGRAY_BRUSH);
    wndclass.lpszMenuName 	= NULL;                                // nie ma menu
    wndclass.lpszClassName	= nazwa_klasy_okien;
    wndclass.hIconSm      	= LoadIcon   (NULL, IDI_APPLICATION);  // ikona
    
    ATOM a = RegisterClassEx (&wndclass);	
    hwnd = CreateWindowEx ( WS_EX_TOPMOST,  // okno zawsze na wierzchu
        nazwa_klasy_okien,                // klasa okna
        "Przyciski w oknie",	          // tytu okna
        WS_DLGFRAME,			          // ramka jak w oknie dialogowym
        CW_USEDEFAULT, CW_USEDEFAULT,     // polozenie okna
        szerokosc + 28, 7*wysokosc + 26,  // szerokosc, wysokosc
        NULL,                             // to okno nie ma okna rodzica
        NULL,                             // nie ma menu
        hInstance,
        NULL
    );
    if (hwnd == 0)
        return -1;

    ShowWindow (hwnd, nCmdShow);			
    UpdateWindow (hwnd);						
    
    /* Ptla komunikatw: */
    int result;
    while ((result = GetMessage (&msg, NULL, 0, 0) ) != 0) 
    {
        if (result == -1) return -1;
        TranslateMessage (&msg);
        DispatchMessage (&msg);            
    }	                                    
    return msg.wParam;
}


// **************************
// ***   PROCEDURA OKNA   ***
// **************************

LRESULT CALLBACK ProceduraOkna (HWND hwnd, UINT message,
                                UINT wParam, LONG lParam)
{
  // trzy identyfikatory przyciskw
  const int numer_edit = 1;
  const int numer_push = 2;
  const int numer_static = 3;
  const int dlugosc_bufora = 150;
   
  static HWND h_edit;     // uchwyt okienka "edytora"
  static HWND h_ok;       // uchwyt okienka przycisku OK
  static HWND h_static;   // uchwyt napisu nad okienkiem "edytora"
  
  switch(message)
  {
    case WM_CREATE: 
      // okno statyczne: zawiera napis informacyjny
      h_static = CreateWindowEx (0,
                  "Static", "Napisz do mnie niekoniecznie krtki list!",
                  WS_CHILD | WS_VISIBLE,         // flagi  
                  10, 10, szerokosc, wysokosc, // polozenie i wielkosc
                  hwnd,
                  HMENU(numer_static),           // numer okienka
                  ::hinst, 0);
      // okno "edytora": umoliwia edycje napisu 
      // (wacznie z obslug ctrl-c, ctrl-v, ctrl-z, alt-backspace)
      h_edit = CreateWindowEx (WS_EX_CLIENTEDGE,
                  "EDIT", "Szanowny Panie,", 
                  WS_CHILD |  WS_VISIBLE | WS_VSCROLL  | WS_HSCROLL |
                  ES_LEFT  | ES_MULTILINE | ES_AUTOHSCROLL | ES_AUTOVSCROLL,
                  10, 10+wysokosc, szerokosc, wysokosc*4,
                  hwnd,
                  HMENU(numer_edit), 
                  ::hinst, 0);
      // tworzymy przycisk OK
      h_ok = CreateWindowEx (0, 
                  "BUTTON", "OK", 
                  WS_CHILD | WS_VISIBLE  | BS_DEFPUSHBUTTON | WS_DISABLED, 
                  10, 20+wysokosc*5, szerokosc, wysokosc,
                  hwnd, 
                  HMENU(numer_push),
                  ::hinst, 0);
                  
      // ograniczmy pojemno okna edycji
      SendMessage(h_edit, EM_SETLIMITTEXT, dlugosc_bufora-1, 0);
      return 0;                     // 0 = "komunikat przetworzony"
    case WM_COMMAND:
    {
      // wParam zawiera zarwno identyfikator okna-rda komunikatu (dolne 16 bitw wParam)
      //  jak i informacj o przyczynie wygenerowania komunikatu (grne 16 bitw wParam)
      int zrodlo_komunikatu = LOWORD(wParam);
      int przyczyna  = HIWORD(wParam);
      if(zrodlo_komunikatu == numer_push)   
      {            
         // przycinito OK
         char bufor[dlugosc_bufora];        // bufor napisu, wprowadzonego do edytora
         GetWindowText(h_edit, bufor, dlugosc_bufora); // odczytuje tekst z "edytora" h_edit
         ShowWindow(hwnd, SW_HIDE);         // ukrywa okno gwne (hwnd)
         MessageBox(hwnd, bufor,            // wyswietla komunikat
                   "W okienku edytora wpisano:", 0);
         DestroyWindow(hwnd);               // niszczy okno gwne (i podrzedne)
         break;
      }
      else if (zrodlo_komunikatu == numer_edit)  // jesli komunikat wygenerowa "edytor"
      {
         if(przyczyna == EN_CHANGE  &&  // poniewaz zmieni sie tekst w edytorze
            !IsWindowEnabled(h_ok))     // i przycisk OK jest wyczony
         {
            EnableWindow(h_ok, true);   // uaktywniamy przycisk OK
            SetWindowText(h_static, "Brawo! Gdy skoczysz, przycinij OK");
         }
         else if (przyczyna == EN_MAXTEXT )
         {
            MessageBox(hwnd, "List nie moe by az tak dugi!", "Bd!",
                       MB_ICONEXCLAMATION);
         }
      }
      return 0;
    }
    case WM_DESTROY:
      PostQuitMessage (0);                 // przerywa WinMain
      return 0;
  }
  return DefWindowProc (hwnd, message, wParam, lParam);
}
