#include <windows.h>
#include <cstdio>
#include "resource.h"
#include "dialog_trojmian.h"
#include "dialog_o_programie.h"
#include "struktura.h"



/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

/*  Make the class name into a global variable  */

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
                    
{
   char szClassName[ ] = "Zbyszek";
   
   HWND hwnd;               /* This is the handle for our window */
   MSG messages;            /* Here messages to the application are saved */
   WNDCLASSEX wincl;        /* Data structure for the windowclass */
   
   /* The Window structure */
   wincl.hInstance = hThisInstance;
   wincl.lpszClassName = szClassName;
   wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
   wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
   wincl.cbSize = sizeof (WNDCLASSEX);
   
   /* Use default icon and mouse-pointer */
   wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
   wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
   wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
   wincl.lpszMenuName = NULL;                 /* No menu */
   wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
   wincl.cbWndExtra = 0;                      /* structure or the window instance */
   /* Use Windows's default color as the background of the window */
   wincl.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
   
   /* Register the window class, and if it fails quit the program */
   if (!RegisterClassEx (&wincl))
      return 0;
   
   /* The class is registered, let's create the program*/
   hwnd = CreateWindowEx (
      0,                   /* Extended possibilites for variation */
      szClassName,         /* Classname */
      "Takie tam okna dialogowe...",       /* Title Text */
      WS_OVERLAPPEDWINDOW, /* default window */
      CW_USEDEFAULT,       /* Windows decides the position */
      CW_USEDEFAULT,       /* where the window ends up on the screen */
      744,                 /* The programs width */
      375,                 /* and height in pixels */
      HWND_DESKTOP,        /* The window is a child-window to desktop */
      LoadMenu(hThisInstance, MAKEINTRESOURCE(IDR_MENU1)),   /* menu */
      hThisInstance,       /* Program Instance handler */
      NULL                 /* No Window Creation data */
      );
   
   /* Make the window visible on the screen */
   ShowWindow (hwnd, nFunsterStil);
   
   /* Run the message loop. It will run until GetMessage() returns 0 */
   while (GetMessage (&messages, NULL, 0, 0))
   {
      /* Translate virtual-key messages into character messages */
      TranslateMessage(&messages);
      /* Send message to WindowProcedure */
      DispatchMessage(&messages);
   }
   
   /* The program return-value is 0 - The value that PostQuitMessage() gave */
   return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
//   static HWND hDialog = 0;
   static QuadraticData qd = {0};
   switch (message)                  /* handle the messages */
   {
   case WM_COMMAND:
      {
         switch (LOWORD(wParam) )
         {
         case  ID_OBLICZ:
            {
               HINSTANCE hinst = (HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE);
               int wynik =  DialogBox(hinst, MAKEINTRESOURCE(IDD_DIALOG1),
                  hwnd, DialogTrojmianProcedure);
         //      hDialog = 0;
         //      SetFocus(hDialog);
               break;
            }
         case ID_POMOC:
            {
               HINSTANCE hinst = (HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE);
               int wynik =  DialogBox(hinst, MAKEINTRESOURCE(IDD_DIALOG2),
                   hwnd, DialogOProgramie);
               break;
            }
         }
         break;
      }
   
   case UM_SET_DATA:
   {
      QuadraticData* pqd = (QuadraticData*) wParam;
      qd = *pqd;
      InvalidateRect(hwnd, 0, true);
      break;
   }
      
      
   case WM_PAINT:
   {
      PAINTSTRUCT ps;
      HDC hdc = BeginPaint(hwnd, &ps);
      RECT client;
      GetClientRect(hwnd, &client);
      char buffer [500];
      if (qd.valid_roots == 2 && !qd.complex_roots)
      {
          sprintf(buffer, "a = %d, b = %d, c = %d\nx0 = %g\nx1 = %g",
                            qd.a, qd.b, qd.c, qd.x0, qd.x1);
          DrawText(hdc, buffer, strlen(buffer), &client, DT_CENTER);
      }
      EndPaint(hwnd, &ps);
      break;
   }
      
   case WM_DESTROY:
      PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
      break;
   default:                      /* for messages that we don't deal with */
      return DefWindowProc (hwnd, message, wParam, lParam);
   }
   
   return 0;
}

